﻿// Accord Math Library
// The Accord.NET Framework
// http://accord-framework.net
//
// Copyright © César Souza, 2009-2015
// cesarsouza at gmail.com
//
//    This library is free software; you can redistribute it and/or
//    modify it under the terms of the GNU Lesser General Public
//    License as published by the Free Software Foundation; either
//    version 2.1 of the License, or (at your option) any later version.
//
//    This library is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//    Lesser General Public License for more details.
//
//    You should have received a copy of the GNU Lesser General Public
//    License along with this library; if not, write to the Free Software
//    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//

namespace Accord.Math.Integration
{
    using System.Runtime.CompilerServices;

    /// <summary>
    ///   Numerical methods for approximating integrals.
    /// </summary>
    /// 
    /// <remarks>
    /// <para>
    ///  This namespace contains different methods for numerically approximating 
    ///  integrals, such as the <see cref="TrapezoidalRule">Trapezoidal Rule</see>,
    ///  <see cref="RombergMethod">Romberg method</see>, up to more advanced versions
    ///  such as the <see cref="InfiniteAdaptiveGaussKronrod">Infinite Adaptive Gauss
    ///  Kronrod</see> for improper integrals or <see cref="MonteCarloIntegration">
    ///  Monte Carlo integration</see> for multivariate integrals.</para>
    ///  
    /// <para>
    ///   The namespace class diagram is shown below. </para>
    ///   <img src="..\diagrams\classes\Accord.Math.Integration.png" />
    /// </remarks>
    /// 
    /// <seealso cref="Accord.Math"/>
    /// <seealso cref="Accord.Math.Differentiation"/>
    ///   
    [CompilerGenerated]
    class NamespaceDoc
    {
    }
}
